/******************************************************************************
 This code gets the disk usage for /tmp for a DEC or a SUN.  (See below for
 extensions to other platforms.)

 define mips for DEC
 define sun for SUN
 define testing for a compileable program with main
 define DEBUG for debugging output

 Hacked up by: Mike Neil on Oct 11, 1990.

 Copyright (C) 1990, 1991, 1992 by the Regents of the University of Michigan.

 User agrees to reproduce said copyright notice on all copies of the software
 made by the recipient.  

 All Rights Reserved. Permission is hereby granted for the recipient to make
 copies and use this software for its own internal purposes only. Recipient of
 this software may re-distribute this software outside of their own
 institution. Permission to market this software commercially, to include this
 product as part of a commercial product, or to make a derivative work for
 commercial purposes, is explicitly prohibited.  All other uses are also
 prohibited unless authorized in writing by the Regents of the University of
 Michigan.

 This software is offered without warranty. The Regents of the University of
 Michigan disclaim all warranties, express or implied, including but not
 limited to the implied warranties of merchantability and fitness for any
 particular purpose. In no event shall the Regents of the University of
 Michigan be liable for loss or damage of any kind, including but not limited
 to incidental, indirect, consequential, or special damages. 
******************************************************************************/
 

#include <stdio.h>


#ifdef mips
#include <sys/types.h>
#include <sys/param.h>
#include <sys/mount.h>


#ifdef __STDC__
long getdisk(void)
#else
long getdisk()
#endif
{
	struct fs_data tempspace;
	
	if (statfs("/tmp", &tempspace) != 1)
		if (statfs("/tmp", &tempspace) != 1)
			tempspace.fd_req.bfreen = 0;
	
	if (tempspace.fd_req.bfreen < 0)
	  tempspace.fd_req.bfreen = 0;
	  
#ifdef DEBUG
	  printf("%d  %d\n", tempspace.fd_req.btot, tempspace.fd_req.bfreen);
                 /*        TotalSpace^     Available User Space */
#endif
	
	return((long)tempspace.fd_req.bfreen);
}
#endif


#if (defined(sun) || defined(_AIX) || defined(hpux))

#include <sys/types.h>
#if (defined(_AIX))
#include <sys/statfs.h>
#else
#include <sys/vfs.h>
#endif

#ifdef __STDC__
long getdisk(void)
#else
long getdisk()
#endif
{
	struct statfs tempspace;
	long num;
	
	if (statfs("/tmp", &tempspace) != 0)
	  if (statfs("/tmp", &tempspace) != 0)
	    tempspace.f_bavail = 0;
	    
	if (tempspace.f_bavail < 0)
	  tempspace.f_bavail = 0;
	  	
#ifdef DEBUG
	  printf("%d  %d\n", tempspace.f_bsize, tempspace.f_bavail);
	/*                 BlockSize^     Available User Space in blocks */
#endif
	
	num = (tempspace.f_bsize * tempspace.f_bavail) / 1024;
	return(num);
}

#endif

#ifdef apollo

#include <sys/types.h>
#include <sys/statfs.h>

#ifdef __STDC__
long getdisk(void)
#else
long getdisk()
#endif
{
	struct statfs tempspace;
	long num;
	
	if (statfs("/tmp", &tempspace,sizeof(tempspace),0) != 0)
	  if (statfs("/tmp", &tempspace,sizeof(tempspace),0) != 0)
	    tempspace.f_bfree = 0;
	    
	if (tempspace.f_bfree < 0)
	  tempspace.f_bfree = 0;
	  	
#ifdef DEBUG
	  printf("%d  %d\n", tempspace.f_bsize, tempspace.f_bfree);
	/*                 BlockSize^     Available User Space in blocks */
#endif
	
	num = (tempspace.f_bfree);
	return(num);
}

#endif

#ifdef testing
main()
{
  printf("%d",getdisk());
}
#endif
