/******************************************************************************
 This code gets the user list.

 Hacked up by: Mike Neil.

 Copyright (C) 1990, 1991, 1992 by the Regents of the University of Michigan.

 User agrees to reproduce said copyright notice on all copies of the software
 made by the recipient.  

 All Rights Reserved. Permission is hereby granted for the recipient to make
 copies and use this software for its own internal purposes only. Recipient of
 this software may re-distribute this software outside of their own
 institution. Permission to market this software commercially, to include this
 product as part of a commercial product, or to make a derivative work for
 commercial purposes, is explicitly prohibited.  All other uses are also
 prohibited unless authorized in writing by the Regents of the University of
 Michigan.

 This software is offered without warranty. The Regents of the University of
 Michigan disclaim all warranties, express or implied, including but not
 limited to the implied warranties of merchantability and fitness for any
 particular purpose. In no event shall the Regents of the University of
 Michigan be liable for loss or damage of any kind, including but not limited
 to incidental, indirect, consequential, or special damages. 
******************************************************************************/
 
#include <stdio.h>
#include <sys/types.h>
#include <utmp.h>

#if (defined(mips) || defined(sun) || defined(hpux))
#include <sys/types.h>
#include <sys/stat.h>
#endif


#ifdef __STDC__
int getusers(int *users,int *console)
#else
int getusers(users,console)
int *users;
int *console;
#endif
{
	struct utmp user;
#ifdef hpux
        struct utmp *utptr;
#endif
#if (defined(mips) || defined(sun) || defined(hpux))
	struct stat buf;
#endif
	int etcutmp;
	int eof = 1;
	char line[9], name[9], host[17];
	
        *users=0;
        *console=0;
#if (defined(mips) || defined (sun) || defined(hpux))
	stat ("/dev/console" , &buf);
	if (buf.st_uid != 0) ++(*console);
#endif

#ifdef hpux
        while (utptr=getutent()) {
                memcpy((char *)&user,(char *)utptr,sizeof(user));
                if (user.ut_type!=USER_PROCESS) continue;
		strncpy(name, user.ut_user, 8);
#else
	etcutmp = open("/etc/utmp", 0);
	while(read (etcutmp, (char *)&user, sizeof(struct utmp))) {
#if !(defined(sun) || defined(mips))
                if (user.ut_type!=USER_PROCESS) continue;
#endif
		strncpy(name, user.ut_name, 8);
#endif
		name[8] = '\0';
		strncpy(line, user.ut_line, 8);
		line[8] = '\0';
		strncpy(host, user.ut_host, 16);
		host[16] = '\0';
#ifdef testing
                printf("name= \"%s\"  line=\"%s\"  host=\"%s\"\n",
                       name,line,host);
#endif
		if (strlen(name)) {
			++(*users);
#if (!defined(mips) && !defined(sun) && !defined(hpux))
			if (!strcmp(line,"console") || !strcmp(host,":0.0") ||
                            !strcmp(line,"display"))
			{
				++(*console);
			}
#endif
		}
	}
#ifdef hpux
        endutent();
#else	
	close(etcutmp);
#endif	  
        return(*users);
}


#ifdef testing
main()
{
     int u,c,rv;

     rv=getusers(&u,&c);
     printf("Results:  rv=%d u=%d c=%d\n",rv,u,c);
}
#endif
