/*****************************************************************************
 PARSER.H - General string parsing module header file

 (c) 1990, 1991, 1992, R. Lee Liming, Jr.
 USED WITH PERMISSION OF THE AUTHOR
 ALL RIGHTS RESERVED

 Defines: char *strip(char *str);
          char *strip_leading(char *str);
          char *scrunch(char *str);
          char *stoupper(char *);
          char *spicture(char *str,int n,char *temp);
          int   whitespace(char ch);
          char *textparam(char *str,int pos,char buf[]);
          char *encapsulate(char *str,char *buf);
          char *breakout(char *str,char *buf);
          int   limits(char *rstr,int *start,int *stop);
          char *strstr(char *str,char target[]);
*****************************************************************************/

#ifndef _PARSER_INCLUDED_

#define _PARSER_INCLUDED_


#ifdef  __STDC__

char *strip(char *);
char *strip_leading(char *);
char *scrunch(char *str);
char *stoupper(char *);
char *spicture(char *str,int n,char *temp);
int   whitespace(char);
char *textparam(char *,int,char []);
char *encapsulate(char *str,char *buf);
char *breakout(char *str,char *buf);
int   limits(char *rstr,int *start,int *stop);
char *strstr(char *,char []);

#else  /* ifndef __STDC__ */

char *strip();
char *strip_leading();
char *scrunch();
char *stoupper();
char *spicture();
int   whitespace();
char *textparam();
char *encapsulate();
char *breakout();
int   limits();
char *strstr();

#endif

#endif  /* _PARSER_INCLUDED_ */
